/*
 * Copyright 2012 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.hoau;

import at.jku.risc.stout.hoau.data.InputParser;
import at.jku.risc.stout.hoau.data.TermNode;
import at.jku.risc.stout.hoau.data.atom.BoundVariable;

/**
 * Some test cases
 * 
 * @author Alexander Baumgartner
 */
public class TestParser {

	public static void main(String[] args) {
		// NodeFactory.PREFIX_IndividualVar = "$";
		BoundVariable.PRINT_ORIGIN_NAME = true;
		// test("\\y.\\x.z1(x,y)");
		test("\\x,y.z1(\\y.y,y)");
		// test("(\\x.x x) (\\x.x x)");
		// test("(\\x,y,z,v,u.f(x(a),y)) g");
		// test("\\x.Y(x,b)");
		// test("\\x:int.\\y.f(x,g(Y,x,b),\\x.x,h(y,x,X(f,g),F(f,g))) test (\\x.x x x) d h \\y.f(y)");
		// test("\\x:t1,y,z. x x x x z");
		// test("\\x. x x x x z");
		// test("(((\\x. x x x) x) z)");
		// test("f(\\x. x x x x z, g)");
	}

	public static void test(String in) {
		try {
			TermNode inTerm = new InputParser().parseSequence(in);
			System.out.println(inTerm);
			System.out.println(inTerm.reduce(10));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
